version: '3'

services:
  reverse-proxy:
    image: traefik:v2.5
    container_name: traefik
    restart: unless-stopped
    security_opt:
      - no-new-privileges:true
    ports:
      # Web
      - 80:80
      - 443:443
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      # Map the static conf into the container
      - ./traefik/traefik.yml:/etc/traefik/traefik.yml:ro
      # Map the dynamic conf into the container
      - ./traefik/config.yml:/etc/traefik/config.yml:ro
      # Map the certificats into the container
      - /home/vagrant/.certs:/etc/certs:ro
    networks:
      - proxy
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.traefik=true"

  api:
    build: Backend
    restart: always
    ports:
      - "5000:5000"
    volumes:
      - /home/vagrant/.certs:/api/certs
    networks:
      - proxy
      - internal
    container_name: api
    security_opt:
      - no-new-privileges:true
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.api.rule=Host(`api.server.appsec`) || (Host(`www.server.appsec`) &&
        PathPrefix(`/api`))"
      - "traefik.http.middlewares.stripapi.stripprefix.prefixes=/api"
      - "traefik.http.routers.api.tls=true"
      - "traefik.http.services.api.loadbalancer.server.port=5000"
      - "traefik.http.middlewares.api-passtlsclientcert.passtlsclientcert.pem=t\
        rue"
      - "traefik.http.middlewares.api-passtlsclientcert.passtlsclientcert.info.\
        notafter=true"
      - "traefik.http.middlewares.api-passtlsclientcert.passtlsclientcert.info.\
        notbefore=true"
      - "traefik.http.middlewares.api-passtlsclientcert.passtlsclientcert.info.\
        serialnumber=true"
      - "traefik.http.middlewares.api-passtlsclientcert.passtlsclientcert.info.\
        subject.commonname=true"
      - "traefik.http.routers.api.middlewares=stripapi, api-passtlsclientcert"
    depends_on:
      - ca_database
    links:
      - ca_database

  frontend:
    build: Frontend
    restart: always
    networks:
      - proxy
    container_name: frontend
    security_opt:
      - no-new-privileges:true
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.frontend.rule=Host(`www.server.appsec`)"
      - "traefik.http.routers.frontend.tls=true"
      - "traefik.http.services.frontend.loadbalancer.server.port=80"

  whoami:
    image: containous/whoami
    container_name: whoami
    security_opt:
      - no-new-privileges:true
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.whoami.rule=Host(`whoami.server.appsec`)"
      - "traefik.http.routers.whoami.tls.options=secure"
    networks:
      - proxy

  ca_database:
    image: mysql:5.7
    restart: always
    environment:
      MYSQL_RANDOM_ROOT_PASSWORD: Ru7xtcQspvxMZHgffBdJ
      MYSQL_DATABASE: ca_database
      MYSQL_USER: ca_user
      MYSQL_PASSWORD: Ru7xtcQspvxMZHgffBdJ
    volumes:
      - ./Database:/var/lib/mysql
    networks:
      - internal

networks:
  proxy:
    external: true
  internal: null
